local prefix = "|cFF0000FFMimironFFA:|r "
local lootmethod, masterlooter, _
local L = {}

-- if your locale is missing, add the appropriate phase 3 and phase 4 yells at
-- http://www.wowace.com/projects/mimironffa/localization/
-- and either write a comment, open a ticket or drop me a line at gnarfoz@gmail.com


if GetLocale() == "enUS" then
	L["not_leader"] = "You are not the raid leader! Cannot change loot method."
L["phase3"] = "^Thank you, friends!"
L["phase4"] = "^Preliminary testing phase complete"
L["Ulduar"] = "Ulduar"

elseif GetLocale() == "deDE" then
    L["not_leader"] = "Du bist nicht Schlachtzugsleiter! Kann die Plündermethode nicht umstellen!"
L["phase3"] = "^Danke Euch, Freunde!"
L["phase4"] = "^Vorversuchsphase abgeschlossen"
L["Ulduar"] = "Ulduar"

elseif GetLocale() == "frFR" then
    L["not_leader"] = "You are not the raid leader! Cannot change loot method." -- Requires localization
L["phase3"] = "^Merci, les amis !"
L["phase4"] = "^Fin de la phase d'essais préliminaires"
L["Ulduar"] = "Ulduar"

elseif GetLocale() == "koKR" then
    L["not_leader"] = "You are not the raid leader! Cannot change loot method." -- Requires localization
L["phase3"] = "^고맙다, 친구들!"
L["phase4"] = "^예비 시험은 이걸로 끝이다"
L["Ulduar"] = "Ulduar" -- Requires localization

elseif GetLocale() == "zhTW" then
    L["not_leader"] = "You are not the raid leader! Cannot change loot method." -- Requires localization
L["phase3"] = "^感謝你"
L["phase4"] = "^初步測試階段完成"
L["Ulduar"] = "Ulduar" -- Requires localization

else
	print(prefix.."This addon has yet to be translated for your locale. Please check the source code to help. Exiting.")
	return
end

local function OnEvent(self, event, arg1)
	if event == "CHAT_MSG_MONSTER_YELL" then
		if arg1:find(L["phase3"]) then
		    SwitchToFFA()
		elseif arg1:find(L["phase4"]) then
		    SwitchBack()
		end
	elseif event == "ZONE_CHANGED_NEW_AREA" then
		if GetRealZoneText() == L["Ulduar"] then
		    MimironFFA:RegisterEvent("CHAT_MSG_MONSTER_YELL")
		else
		    if MimironFFA:IsEventRegistered("CHAT_MSG_MONSTER_YELL") then
				MimironFFA:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
			end
		end
	end
end

local function SwitchToFFA() --switches to FFA loot for phase 3
	if isRaidLeader() then
        lootmethod, _, masterlooter = GetLootMethod()
        if lootmethod ~= "freeforall" then
            SetLootMethod("freeforall")
        end
	else
		print(prefix..L["not_leader"])
	end
end

local function SwitchBack() --switches back to whatever loot method was used previously
	if isRaidLeader() then
		if lootmethod == "master" and masterlooter == true then
		    SetLootMethod(lootmethod, UnitName(masterlooter))
		else
		    SetLootMethod(lootmethod)
		end
	else
		print(prefix..L["not_leader"])
	end
end

-- Create frame for events, set OnEvent and register for Z_C_N_A for activation/deactivation purposes
local MimironFFA = CreateFrame("Frame")
MimironFFA:SetScript("OnEvent", OnEvent)
MimironFFA:RegisterEvent("ZONE_CHANGED_NEW_AREA")